#include <stdio.h>
#include "TextAnalyse.h"
#include <windows.h>
#include <string.h>
#include <malloc.h>

// ǂݍݗpNXIuWFNg
TextAnalyse dhtxt, dxtxt, ttxt;

// ֐
struct FUNCTIONNAME
{
	int				Counter;				// ֐̐
	char			Name[ 64 ];				// ֐
} ;

// Cf[^
struct MAIN
{
	char			*Struct;				// DxLib.h ̍\̂`Ă镔̕
	char			*Function;				// DxLib.h ̊֐`Ă镔̕

	int				FuncNameNum ;			// ֐̐
	FUNCTIONNAME	FuncName[ 65536 ] ;		// ֐
} dat;

// ֐̈Ɋւ
struct PARAMETER
{
	bool			ValidDefault;			// ftHgLǂ
	bool			Out;					// out ǂ
	char			Default[64];			// ftHg̕
	char			CPPType[64];			// C++ ł̌^
	char			CSType[64];				// C# ł̌^
	char			Name[64];				// 
};

// ֐Ɋւ
struct FUNCTION
{
	bool			Void;					// ߂ľ^ void ^ǂ
	char			CPPType[64];			// C++ ł̖߂ľ^
	char			CSType[64];				// C# ł̖߂ľ^
	char			Name[64];				// ֐
	
	PARAMETER		Parameter[64];			// ̏
	int				ParameterNum;			// ̐
	int				DefaultNum;				// ftHg̐
};

// ^ϊŎgp
struct TYPEINFO
{
	const char		*CPPName ;				// C++ ł̌^
	const char		*CSName ;				// C# ł̌^
	int				Size ;					// ^̃TCY( byte )
} ;


// ^̕ϊ
TYPEINFO TypeInfoDim[] =
{
	"void",						NULL,					0,
	"HWND",						"System.IntPtr",		4,
	"DX_CHAR",					"byte",					1,
	"WORD",						"ushort",				2,
	"BYTE",						"byte",					1,
	"LONGLONG",					"long",					8,
	"ULONGLONG",				"ulong",				8,
	"size_t",					"uint",					4,
	"int",						NULL,					4,
	"short",					NULL,					2,
	"char",						NULL,					1,
	"TCHAR",					"char",					1,
	"float",					NULL,					4,
	"double",					NULL,					8,
	"VECTOR",					NULL,					12,
	"MATRIX",					NULL,					64,
	"RECT",						NULL,					16,
	"DATEDATA",					NULL,					24,
	"IPDATA",					NULL,					4,
	"IPDATA_IPv6",				NULL,					16,
	"COLOR_F",					NULL,					16,
	"COLOR_U8",					NULL,					4,
	"UV",						NULL,					8,
	"BOOL",						"int",					4,
	"COLORDATA",				NULL,					1064,
	"HITRESULT_LINE",			NULL,					16,
	"MV1_COLL_RESULT_POLY",		NULL,					72,
	"MV1_COLL_RESULT_POLY_DIM",	NULL,					8,
	"MV1_REF_VERTEX",			NULL,					40,
	"MV1_REF_POLYGON",			NULL,					48,
	"DISPLAYMODEDATA",			NULL,					16,
	NULL, NULL, -1,
} ;

// DLL ɂ̂ݏo͂ C# pɂ͏o͂Ȃ֐̃Xg
char *DLLOnlyFunction[] =
{
	"ClearDrawScreen", "ClearDrawScreenZBuffer",
	"GetTexPixelFormat", "GetTexColorData", "LoadGraphToResource", "GetWindowSizeChangeEnableFlag",
	"DrawChipMap", "BltBaseImage", "CreateGraphFromGraphImage",
	"ReCreateGraphFromGraphImage", "CreateDivGraphFromGraphImage", "ReCreateDivGraphFromGraphImage",
	"MemStreamOpen", "MemStreamClose",
	"GetDrawTargetSurface", "GetPrimarySurface", "GetBackSurface",
	"GetWorkSurface", "GetUseDDrawObj", "GetPixelFormat",
	"GetOverlayPixelFormat", "GetDirectDrawCaps", "GetDrawScreenDC",
	"GetDirectDrawDeviceGUID", "GetUseD3DDevObj", "GetVertexBuffer",
	"GetTexPixelFormat", "GetTexColorData", "GetTexPixelFormat",
	"GetTexColorData", "GetTexPixelFormat", "GetTexColorData",
	"GetZBufferPixelFormat", "GraphColorMatchBltVer2", "GetFullColorImage",
	"GetResourceIDString", "CreateDIBGraphVer2", "SetHookWinProc",
	"FileRead_getInfo", "FileRead_findFirst", "FileRead_findNext", "FileRead_findClose",
	NULL,
};

// ؏o͂Ȃ֐̃Xg
char *SkipFunction[] =
{
	"SetBeepFrequency", "PlayBeep", "StopBeep",
	"ErrorLogFmtAdd", "AppLogAdd", "printfDx", "FileRead_scanf", "DrawFormatString",
	"DrawFormatVString", "DrawFormatStringToHandle", "DrawFormatVStringToHandle",
	"DrawExtendFormatString", "DrawExtendFormatVString", "DrawExtendFormatStringToHandle",
	"DrawExtendFormatVStringToHandle", "DrawFormatStringMask", "DrawFormatStringMaskToHandle",
	"GetDrawFormatStringWidth", "GetDrawFormatStringWidthToHandle", 
	"GetDrawExtendFormatStringWidth", "GetDrawExtendFormatStringWidthToHandle",
	"DrawFormatStringToZBuffer", "DrawFormatVStringToZBuffer", "DrawFormatStringToHandleToZBuffer",
	"DrawFormatVStringToHandleToZBuffer", "DrawExtendFormatStringToZBuffer", "DrawExtendFormatVStringToZBuffer",
	"DrawExtendFormatStringToHandleToZBuffer", "DrawExtendFormatVStringToHandleToZBuffer",
	"SetKeyInputStringColor",
	NULL,
} ;

// }ÑXg
char *SkipDefine[] =
{
	"STTELL(", "STSEEK(", "STREAD(", "STWRITE(", "STEOF(", "STCLOSE(",
	"STREAM_SEEKTYPE_SET", "STREAM_SEEKTYPE_END", "STREAM_SEEKTYPE_CUR",
	"DEFAULT_FOV", "DEFAULT_TAN_FOV_HALF", "DEFAULT_NEAR", "DEFAULT_FAR",
	"DEFAULT_FONT_SIZE", "DEFAULT_FONT_THINCK", "DEFAULT_FONT_TYPE", "DEFAULT_FONT_EDGESIZE",
	NULL,
};


int		AddFunctionName( const char *Name ) ;								// ֐ǉ( ߂lFO̊֐̐ )

int		CheckSkipFunc( char *str );											// ẘ֐XLbv邩ǂ𒲂ׂ( 0:XLbvȂ  1:DLLɂ̂ݏo͂  2:XLbv )
bool	CheckSkipDefine( char *str );										// w̃}N𖳎邩ǂ𒲂ׂ( true:XLbv  false:XLbvȂ )
bool	CheckSkipType( TextAnalyse *txt, bool function, bool *unsafe );		// ^炻̊֐C#̃vOɏoׂ͂𒲂ׂ( true:o͂Ȃ  false:o͂ )
bool	CheckSkipStruct( char *source );									// w̍\̂̒g疳\̂ǂ𔻒f( true:XLbv  false:XLbvȂ )

bool	GetDirectXDefineStr( char *search, char *buffer );					// wDirectX}N̐l擾( true:  false:s )
void	GetNumberOrIdentifier( char *src, char *dest );						// w̕񂩂琔͎ʎq𔲂o

int		TypeConv( TextAnalyse *txt, char *CSType, bool UseSize, char *CPPType, bool *pOutFlag, bool Struct, bool Unsafe );		// C++ p̌^ C# p̌^ɕϊ( ߂lF^̃TCY( byte ) )
void	Conv16To10( char *src, char *dest );								// PUi̕POi̕ɕϊ
int		ConvTokenStr( int bufferPos, char *buffer, char *src );				// w̕񒆂̍\ԂɃXy[X镶ɕϊ
void	CreateTokenStr( void );												// \ԂɃXy[X镶쐬

void	OutputDefineStr( FILE *cs ) ;										// 萔`o͂
void	OutputStructStr( FILE *cs ) ;										// \̒`o͂
void	OutputBetaFunctionStr( FILE *cs, FILE *sc, FILE *def, FILE *hd ) ;	// x^o͂̊֐`o͂
void	OutputFunctionStr( FILE *cs, FILE *sc, FILE *def, FILE *hd ) ;		// ֐`o͂


// ֐ǉ( ߂lFO̊֐̐ )
int AddFunctionName( const char *Name )
{
	int i ;

	// ɓ֐邩ׂ
	for( i = 0 ; i < dat.FuncNameNum ; i ++ )
	{
		if( strcmp( dat.FuncName[ i ].Name, Name ) == 0 )
			break ;
	}

	// VKɒǉ
	if( i == dat.FuncNameNum )
	{
		dat.FuncName[ dat.FuncNameNum ].Counter = 1 ;
		strcpy( dat.FuncName[ dat.FuncNameNum ].Name, Name ) ;
		dat.FuncNameNum ++ ;
		return 1 ;
	}
	else
	{
		// 瓯֐̐CNg
		dat.FuncName[ i ].Counter ++ ;
		return dat.FuncName[ i ].Counter ;
	}
}

// ẘ֐XLbv邩ǂ𒲂ׂ( 0:XLbvȂ  1:DLLɂ̂ݏo͂  2:XLbv )
int CheckSkipFunc( char *str )
{
	int i;
	
	for( i = 0; SkipFunction[i]; i++ )
	{
		if( strcmp( SkipFunction[i], str ) == 0 )
			return 2;
	}

	for( i = 0; DLLOnlyFunction[i]; i ++ )
	{
		if( strcmp( DLLOnlyFunction[i], str ) == 0 )
			return 1;
	}

	return 0;
}

// w̃}N𖳎邩ǂ𒲂ׂ( true:XLbv  false:XLbvȂ )
bool CheckSkipDefine( char *str )
{
	int i;
	char Str[256];

	strcpy( Str, str );
	
	for( i = 0; SkipDefine[i]; i ++ )
	{
		if( strcmp( SkipDefine[i], Str ) == 0 )
			return true;
	}

	return false;
}

// ^炻̊֐C#̃vOɏoׂ͂𒲂ׂ( true:o͂Ȃ  false:o͂ )
bool CheckSkipType( TextAnalyse *txt, bool function, bool *unsafe )
{
	char *base;
	char Str[256], Str2[256], Str3[256];

	base = txt->getpos();
	txt->getstr( Str );

	// const ̓̕XLbv
	if( strcmp( Str, "const" ) == 0 )
	{
		txt->getstr( Str );
	}

	txt->getstr( Str2 );
	txt->getstr( Str3 );
	txt->move( base );

	// |C^̃|C^̓XLbvΏ
	if( strcmp( Str2, "*" ) == 0 && strcmp( Str3, "*" ) == 0 ) return true;

	// ϒXLbvΏ
	if( strcmp( Str, "..." ) == 0 ) return true;

	// ȉ̌^XLbvΏ
	if( strcmp( Str, "HMODULE" ) == 0 ) return true;
//	if( strcmp( Str, "HWND" ) == 0 ) return true;
	if( strcmp( Str, "HDC" ) == 0 ) return true;
	if( strcmp( Str, "STREAMDATASHREDTYPE2" ) == 0 ) return true;
	if( strcmp( Str, "BASEIMAGE" ) == 0 ) return true;
	if( strcmp( Str, "GUID" ) == 0 ) return true;
//	if( strcmp( Str, "MATRIX" ) == 0 ) return true;
//	if( strcmp( Str, "COLORDATA" ) == 0 ) return true;
	if( strcmp( Str, "HBITMAP" ) == 0 ) return true;
	if( strcmp( Str, "BITMAPINFO" ) == 0 ) return true;
	if( strcmp( Str, "WAVEFORMATEX" ) == 0 ) return true;
	if( strcmp( Str, "STREAMDATA" ) == 0 ) return true;
	if( strncmp( Str, "D_", 2 ) == 0 ) return true;

	// ֐̖߂ľ^`FbNǂŏ𕪊
	if( function )
	{
		// |C^Ԃ֐ unsafe ̂ݗL
		if( strcmp( Str2, "*" ) == 0 )
		{
			*unsafe = true ;
		}

		// ֐̖߂lȉ̌^ȊȌꍇ̓XLbv
		if( strcmp( Str, "DWORD" ) != 0 &&
			strcmp( Str, "int" ) != 0 &&
			strcmp( Str, "void" ) != 0 &&
			strcmp( Str, "float" ) != 0 &&
			strcmp( Str, "FLOAT4" ) != 0 &&
			strcmp( Str, "BOOL" ) != 0 &&
			strcmp( Str, "LONGLONG" ) != 0 &&
			strcmp( Str, "ULONGLONG" ) != 0 &&
			strcmp( Str, "VECTOR" ) != 0 &&
			strcmp( Str, "HITRESULT_LINE" ) != 0 &&
			strcmp( Str, "MATRIX" ) != 0 &&
			strcmp( Str, "size_t" ) != 0 &&
			strcmp( Str, "COLOR_F" ) != 0 &&
			strcmp( Str, "COLOR_U8" ) != 0 &&
			strcmp( Str, "MV1_COLL_RESULT_POLY_DIM" ) != 0 &&
			strcmp( Str, "MV1_COLL_RESULT_POLY" ) != 0 &&
			strcmp( Str, "DISPLAYMODEDATA" ) != 0 ) return true;
	}
	else
	{
		// IPDATA ̃|C^ void ^|C^ unsafe ̂ݗL
		if( ( strcmp( Str, "IPDATA_IPv6" ) == 0 && strcmp( Str2, "*" ) == 0 ) || 
			( strcmp( Str, "IPDATA" ) == 0 && strcmp( Str2, "*" ) == 0 ) || 
			( strcmp( Str, "void" ) == 0   && strcmp( Str2, "*" ) == 0 ) )
		{
			*unsafe = true ;
		}
	}

	return false;
}

// w̍\̂̒g疳\̂ǂ𔻒f( true:XLbv  false:XLbvȂ )
bool CheckSkipStruct( char *source )
{
	// \̂̒Ɉȉ̕񂪊܂܂Ăo͂Ȃ
	if( strstr( source, "union" ) ) return true;
	if( strstr( source, "struct" ) ) return true;
	if( strstr( source, "[" ) ) return true;
//	if( strstr( source, "*" ) ) return true;
//	if( strstr( source, "COLORDATA" ) ) return true;
	if( strstr( source, "STREAMDATASHRED" ) ) return true;

	return false;
}

// wDirectX}N̐l擾( true:  false:s )
bool GetDirectXDefineStr( char *search, char *buffer )
{
	char str[256], str2[256], searchstr[256];

	// ŏɌ镶Zbg
	strcpy( searchstr, search );

	for(;;)
	{
		// DxDirectX.h  DX_NOUSE_DIRECTX_SDK_FILE LqĂƂ܂ňړ
		dxtxt.reset();
		dxtxt.search( "DX_NOUSE_DIRECTX_SDK_FILE" );

		// 
		if( dxtxt.search( searchstr ) )
		{
			// 擾
			dxtxt.getstr( str );

			// enum ̏ꍇ = ̌̕擾
			if( strcmp( str, "=" ) == 0 )
			{
				dxtxt.getstr( str );
			}

			// enum ̏ꍇ͖[ , 肷̂ŁAʎq␔lɎgpł镶̕擾
			GetNumberOrIdentifier( str, str2 );

			// 擪ł͂Ȃꍇ͕ʂ̃}NƔf
			if( str2[0] < '0' || str2[0] > '9' )
			{
				// 镶ύXĂɌs
				strcpy( searchstr, str2 );
				continue;
			}

			// 16ỉ\l10iɕϊ鏈s
			Conv16To10( str2, str );

			// lۑ
			strcpy( buffer, str );

			// 
			return true;
		}
		else
		{
			// G[
			return false;
		}
	}

	// ɗ邱Ƃ͂ȂǈꉞG[
	return false;
}

// w̕񂩂琔͎ʎq𔲂o
void GetNumberOrIdentifier( char *src, char *dest )
{
	// w̕񂩂环ʎqɎgp邱Ƃł镶݂̂𔲂o
	for(;;)
	{
		if( *src == '\0' ) break;
		if( ( *src >= 'a' && *src <= 'z' ) ||
			( *src >= 'A' && *src <= 'Z' ) ||
			( *src >= '0' && *src <= '9' ) ||
			*src == '_' )
		{
			*dest = *src;
			dest ++;
		}
		src ++ ;
	}
	*dest = '\0';
}

// C++ p̌^ C# p̌^ɕϊ( ߂lF^̃TCY( byte ) )
int TypeConv( TextAnalyse *txt, char *CSType, bool UseSize, char *CPPType, bool *pOutFlag, bool Struct, bool Unsafe )
{
	char Str1[256], Str2[256], Str3[256], Str4[256];
	char cstype[64];
	int i, k, cppobj_usenum = 1, typebytes;
	char *start;

	// pz񏉊
	memset( Str1, 0, sizeof( Str1 ) );
	memset( Str2, 0, sizeof( Str2 ) );
	memset( Str3, 0, sizeof( Str3 ) );
	memset( Str4, 0, sizeof( Str4 ) );
	start = txt->getpos();
	txt->getstr( Str1 );
	txt->getstr( Str2 );
	txt->getstr( Str3 );
	txt->getstr( Str4 );
	txt->move( start );

	// ŏ out ^Cvł͂ȂAɂĂ
	if( pOutFlag ) *pOutFlag = false;

	// C# ł̌^擾鏈
	for(;;)
	{
		// const tꍇ͕ʏ
		if( strcmp( Str1, "const" ) == 0 )
		{
			// const void * ̏ꍇ͓Ȃ̂łŏĂ܂
			if( strcmp( Str2, "void" ) == 0 && strcmp( Str3, "*" ) == 0 )
			{
				txt->getstr( Str4 );
				txt->getstr( Str4 );
				txt->getstr( Str4 );
				sprintf( CPPType, "%s %s %s", Str1, Str2, Str3 );
				strcpy( CSType, "void * " );
				return 4;
			}

			// const IMEINPUTCLAUSEDATA * ̏ꍇ͓Ȃ̂łŏĂ܂
			if( strcmp( Str2, "IMEINPUTCLAUSEDATA" ) == 0 && strcmp( Str3, "*" ) == 0 )
			{
				txt->getstr( Str4 );
				txt->getstr( Str4 );
				txt->getstr( Str4 );
				sprintf( CPPType, "%s %s %s", Str1, Str2, Str3 );
				strcpy( CSType, "uint " );
				return 4;
			}

			// const char **  const char * ̏ꍇ͓Ȃ̂łŏĂ܂
			if( strcmp( Str2, "char" ) == 0 || strcmp( Str2, "TCHAR" ) == 0 )
			{
				if( strcmp( Str3, "*" ) == 0 && strcmp( Str4, "*" ) == 0 )
				{
					txt->getstr( Str4 );
					txt->getstr( Str4 );
					txt->getstr( Str4 );
					txt->getstr( Str4 );
					sprintf( CPPType, "%s char %s %s", Str1, Str3, Str4 );
					strcpy( CSType, "uint " );
					return 4;
				}
				if( strcmp( Str3, "*" ) == 0 )
				{
					txt->getstr( Str4 );
					txt->getstr( Str4 );
					txt->getstr( Str4 );
					sprintf( CPPType, "%s char %s ", Str1, Str3 );

					// \̂̏ꍇ uint
					if( Struct )
					{
						strcpy( CSType, "uint " );
					}
					else
					{
						strcpy( CSType, "string " );
					}
					return 4;
				}
			}
		}

		// unsigned tꍇ̏
		if( strcmp( Str1, "unsigned" ) == 0 )
		{
			cppobj_usenum = 2;
			if( strcmp( Str2, "int" ) == 0 )
			{
				strcpy( cstype, "uint" );
				typebytes = 4;
				break;
			}

			if( strcmp( Str2, "short" ) == 0 )
			{
				strcpy( cstype, "ushort" );
				typebytes = 2;
				break;
			}

			if( strcmp( Str2, "char" ) == 0 || strcmp( Str2, "TCHAR" ) == 0 )
			{
				strcpy( cstype, "byte" );
				typebytes = 1;
				break;
			}
		}

		// DWORD  GetColor ̊֐̖߂lǂŏ𕪊
		if( strcmp( Str1, "DWORD" ) == 0 )
		{
			if( strcmp( Str2, "GetColor" ) == 0 )
			{
				strcpy( cstype, "int" );
			}
			else
			{
				strcpy( cstype, "uint" );
			}
			typebytes = 4;
			break;
		}

		// ̑̈ʓIȕϊ̓e[ugčs
		for( k = 0 ; TypeInfoDim[ k ].CPPName ; k ++ )
		{
			if( strcmp( TypeInfoDim[ k ].CPPName, Str1 ) == 0 ) break ;
		}

		// e[u̒猩ꍇ͂̏Zbg
		if( TypeInfoDim[ k ].CPPName != NULL )
		{
			strcpy( cstype, TypeInfoDim[ k ].CSName == NULL ? TypeInfoDim[ k ].CPPName : TypeInfoDim[ k ].CSName ) ;
			typebytes = TypeInfoDim[ k ].Size ;
		}
		else
		{
			// Ȃꍇ̏
			if( UseSize == true )
			{
				printf( "%s error\n", Str1 );
				for(;;){}
				break;
			}
			strcpy( cstype, Str1 );
			typebytes = 4;
		}
		break;
	}

	// C++ ̌^쐬
	strcpy( CPPType, "" );
	for( i = 0; i < cppobj_usenum; i ++ )
	{
		txt->getstr( Str1 );
		strcat( CPPType, Str1 );
		strcat( CPPType, " " );
	}

	// |C^̏ꍇ͏𕪊
	if( txt->nextchar() == '*' )
	{
		txt->getstr( Str1 );

		// \̂̃oϐ̏ꍇ unsigned int ^̕ϐƂ
		if( Struct )
		{
			strcpy( CSType, "uint " ) ;
		}
		else
		{
			// ̏ꍇ System.Text.StringBuilder ^Ƃ
			if( strcmp( cstype, "char" ) == 0 )
			{
				sprintf( CSType, "System.Text.StringBuilder " );
			}
			else
			// void ^̏ꍇ void ^|C^
			if( strcmp( cstype, "void" ) == 0 )
			{
				sprintf( CSType, "void * " );
			}
			else
			// ȊȌꍇ unsafe ̏ꍇ͂̂܂܃|C^Ƃ
			if( Unsafe )
			{
				sprintf( CSType, "%s * ", cstype );
			}
			else
			// unsafe ł͂Ȃꍇ out ť^Ƃ
			{
				sprintf( CSType, "out %s ", cstype );
			}
			if( pOutFlag ) *pOutFlag = true;
		}

		// |C^̏ꍇ̓TCY 4byte
		typebytes = 4;

		// C++ ̌^ɂ͕ʂ * ǉ
		strcat( CPPType, "* " );
	}
	else
	{
		// |C^ł͂Ȃꍇ͓ꂽ^̂܂ܕԂ
		sprintf( CSType, "%s ", cstype );
	}

	// ^̃TCYԂ
	return typebytes;
}

// PUi̕POi̕ɕϊ
void Conv16To10( char *src, char *dest )
{
	// 16i̕ł͂Ȃ炽Rs[邾
	if( src[0] == '0' && src[1] == 'x' )
	{
		int i, j, num[16], digit, total;

		// e̐l𓾂
		src += 2;
		i = 0;
		for( i = 0; *src != '\0'; src++, i++)
		{
			if( *src >= 'a' && *src <= 'f' )
			{
				num[i] = *src - 'a' + 10;
			}
			else
			if( *src >= 'A' && *src <= 'F' )
			{
				num[i] = *src - 'A' + 10;
			}
			else
			{
				num[i] = *src - '0';
			}
		}
		digit = i;

		// l𓾂
		j = 0;
		total = 0;
		for( i = 0; i < digit; i ++, j += 4 )
		{
			total |= num[digit-1-i] << j;
		}

		// 10i̕𓾂
		itoa( total, dest, 10 );
	}
	else
	{
		strcpy( dest, src );
	}
}

// w̕񒆂̍\ԂɃXy[X镶ɕϊ
int ConvTokenStr( int bufferPos, char *buffer, char *src )
{
	for(;;)
	{
		switch( src[0] )
		{
		case '\0':
			buffer[bufferPos] = ' ';
			bufferPos ++ ;
			return bufferPos;

		case '(': case ')': case '[': case ']':
		case '*': case ',': case ';':
			buffer[bufferPos]   = ' ';
			buffer[bufferPos+1] = src[0];
			buffer[bufferPos+2] = ' ';
			bufferPos += 3;
			break;

		default:
			buffer[bufferPos] = src[0];
			bufferPos ++ ;
			break;
		}
		src ++ ;
	}
}

// \ԂɃXy[X镶쐬
void CreateTokenStr( void )
{
	char str1[256] ;
	int pos;

	dat.Struct   = (char *)malloc( 1024 * 1024 * 16 );
	dat.Function = (char *)malloc( 1024 * 1024 * 16 );

	// \̂`ĂƂ܂ňړ
	dhtxt.reset() ;
	dhtxt.search( "DX_STRUCT_START" );
	pos = 0;
	for(;;)
	{
		if( dhtxt.getstr( str1 ) == false ) break;
		if( strcmp( str1, "DX_STRUCT_END" ) == 0 ) break;
		pos = ConvTokenStr( pos, dat.Struct, str1 );
	}
	dat.Struct[pos] = '\0';

	dhtxt.search( "DX_FUNCTION_START" );
	pos = 0;
	for(;;)
	{
		if( dhtxt.getstr( str1 ) == false ) break;
		if( strcmp( str1, "DX_FUNCTION_END" ) == 0 ) break;
		pos = ConvTokenStr( pos, dat.Function, str1 );
	}
	dat.Function[pos] = '\0';
}

// cwCu̒萔`o͂
void OutputDefineStr( FILE *cs )
{
	char Str[256], Str2[256] ;

	// TRUE  FALSE ̒`o
	fprintf( cs, "\t\tpublic const int TRUE  = 1;\n" );
	fprintf( cs, "\t\tpublic const int FALSE = 0;\n" );

	// define ܂Ŕ
	dhtxt.reset();
	dhtxt.search( "DX_DEFINE_START" );
	for(;;)
	{
		// #define T
		dhtxt.getstr( Str );
		if( strcmp( Str, "#define" ) == 0 )
		{
			// DX_DEFINE_END I
			dhtxt.getstr( Str );
			if( strcmp( Str, "DX_DEFINE_END" ) == 0 ) break;

			// }Nꍇ continue
			if( CheckSkipDefine( Str ) ) continue;

			// 萔̏o
			fprintf( cs, "\t\tpublic const int %s = ", Str );

			// 萔̎擾
			dhtxt.getstr( Str );

			// ( ꍇ ) 镔܂ŏo
			if( strcmp( Str, "(" ) == 0 )
			{
				fprintf( cs, "( " );
				for(;;)
				{
					dhtxt.getstr( Str );
					if( strcmp( Str, ")" ) == 0 ) break;
					fprintf( cs, "%s ", Str );
				}
				fprintf( cs, " );\n" );
			}
			else
			// ( lꍇ͐l݂̂𔲂oAPUi̐lPOiɕϊďo
			if( Str[0] == '(' || ( Str[0] >= '0' && Str[0] <= '9' ) )
			{
				GetNumberOrIdentifier( Str, Str2 );
				Conv16To10( Str2, Str );
				fprintf( cs, "%s;\n", Str );
			}
			else
			// ȊȌꍇ DirectX ̒`̂܂܎gpĂ̂ DxDirectX.h 萔擾ďo
			{
				if( GetDirectXDefineStr( Str, Str2 ) == false )
				{
					printf( "%s error\n", Str );
					for(;;){}
				}
				fprintf( cs, "%s;\n", Str2 );
			}
		}
	}
	fprintf( cs, "\n" );
}

// \̕o͂
void OutputStructStr( FILE *cs )
{
	char Str[256], Str2[2024 * 10], Str3[256] ;
	char *start, *end ;
	int count, size ;

	// ł͏o͂łȂ\̂x^o
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct IPDATA_IPv6\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public byte Byte00;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(1)] public byte Byte01;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(2)] public byte Byte02;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(3)] public byte Byte03;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(4)] public byte Byte04;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(5)] public byte Byte05;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(6)] public byte Byte06;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(7)] public byte Byte07;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(8)] public byte Byte08;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(9)] public byte Byte09;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(10)] public byte Byte10;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(11)] public byte Byte11;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(12)] public byte Byte12;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(13)] public byte Byte13;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(14)] public byte Byte14;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(15)] public byte Byte15;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct IPDATA\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public byte d1;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(1)] public byte d2;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(2)] public byte d3;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(3)] public byte d4;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct RECT\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public int left;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(4)] public int top;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(8)] public int right;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(12)] public int bottom;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct MATRIX\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public float m00;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(4)] public float m01;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(8)] public float m02;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(12)] public float m03;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(16)] public float m10;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(20)] public float m11;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(24)] public float m12;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(28)] public float m13;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(32)] public float m20;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(36)] public float m21;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(40)] public float m22;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(44)] public float m23;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(48)] public float m30;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(52)] public float m31;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(56)] public float m32;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(60)] public float m33;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct COLORDATA\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public short ColorBitDepth;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(2)] public short PixelByte;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(4)] public byte RedWidth ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(5)] public byte GreenWidth ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(6)] public byte BlueWidth ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(7)] public byte AlphaWidth ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(8)] public byte RedLoc ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(9)] public byte GreenLoc ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(10)] public byte BlueLoc ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(11)] public byte AlphaLoc ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(12)] public uint RedMask ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(16)] public uint GreenMask ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(20)] public uint BlueMask ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(24)] public uint AlphaMask ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(28)] public uint NoneMask ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(32)] public COLORPALETTEDATA Palette ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(1056)] public byte NoneLoc ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(1057)] public byte NoneWidth ;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(1060)] public int Format ;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct MV1_COLL_RESULT_POLY\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public int HitFlag;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(4)] public VECTOR HitPosition;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(16)] public int FrameIndex;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(20)] public int PolyIndex;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(24)] public int MaterialIndex;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(28)] public VECTOR Position0;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(40)] public VECTOR Position1;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(52)] public VECTOR Position2;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(64)] public VECTOR Normal;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct MV1_REF_POLYGON\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public ushort FrameIndex;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(2)] public ushort MaterialIndex;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(4)] public int VIndexTarget;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(8)] public int VIndex0;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(12)] public int VIndex1;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(16)] public int VIndex2;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(20)] public VECTOR MinPosition;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(32)] public VECTOR MaxPosition;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct MV1_REF_VERTEX\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public VECTOR Position;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(12)] public VECTOR Normal;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(24)] public UV TexCoord0;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(32)] public UV TexCoord1;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(40)] public COLOR_U8 DiffuseColor;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(44)] public COLOR_U8 SpecularColor;\n" );
	fprintf( cs, "\t\t};\n\n" );
	fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
	fprintf( cs, "\t\tpublic struct DINPUT_JOYSTATE\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\t[FieldOffset(0)] public int X;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(4)] public int Y;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(8)] public int Z;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(12)] public int Rx;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(16)] public int Ry;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(20)] public int Rz;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(24)] public int Slider0;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(28)] public int Slider1;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(32)] public uint POV0;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(36)] public uint POV1;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(40)] public uint POV2;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(44)] public uint POV3;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(48)] public byte Buttons0;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(49)] public byte Buttons1;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(50)] public byte Buttons2;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(51)] public byte Buttons3;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(52)] public byte Buttons4;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(53)] public byte Buttons5;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(54)] public byte Buttons6;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(55)] public byte Buttons7;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(56)] public byte Buttons8;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(57)] public byte Buttons9;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(58)] public byte Buttons10;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(59)] public byte Buttons11;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(60)] public byte Buttons12;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(61)] public byte Buttons13;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(62)] public byte Buttons14;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(63)] public byte Buttons15;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(64)] public byte Buttons16;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(65)] public byte Buttons17;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(66)] public byte Buttons18;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(67)] public byte Buttons19;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(68)] public byte Buttons20;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(69)] public byte Buttons21;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(70)] public byte Buttons22;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(71)] public byte Buttons23;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(72)] public byte Buttons24;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(73)] public byte Buttons25;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(74)] public byte Buttons26;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(75)] public byte Buttons27;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(76)] public byte Buttons28;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(77)] public byte Buttons29;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(78)] public byte Buttons30;\n" );
	fprintf( cs, "\t\t\t[FieldOffset(79)] public byte Buttons31;\n" );
	fprintf( cs, "\t\t};\n\n" );

	// ͏
	dhtxt.reset();
	ttxt.setmem( dat.Struct );
	for(;;)
	{
		// struct T
		if( ttxt.getstr( Str ) == false ) break;
		if( strcmp( Str, "struct" ) == 0 )
		{
			// \̂̒g̕ۂ Str2 ɃRs[
			start = ttxt.getpos();
			ttxt.skipgroup( "{", "}" );
			end = ttxt.getpos();
			strncpy( Str2, start, end - start );
			Str2[end-start] = '\0';

			// \̂̒g疳\̂ǂ`FbN
			if( CheckSkipStruct( Str2 ) ) continue;

			// \̒`̏o
			ttxt.getstr( Str );
			fprintf( cs, "\t\t[StructLayout(LayoutKind.Explicit)]\n" );
			fprintf( cs, "\t\tpublic struct %s\n", Str );
			fprintf( cs, "\t\t{\n" );
			ttxt.move( start );
			ttxt.search( "{" );

			count = 0;
			for(;;)
			{

				// } ɗI
				start = ttxt.getpos();
				ttxt.getstr( Str );
				if( strcmp( Str, "}" ) == 0 ) break;
				ttxt.move( start );

				// ^ C# pɕϊ
				size = TypeConv( &ttxt, Str2, true, Str3, NULL, true, false );
				for(;;)
				{
					// ϐ擾
					ttxt.getstr( Str );

					// ϐ̒`o
					fprintf( cs, "\t\t\t[FieldOffset(%d)] public %s %s;\n", count, Str2, Str );
					count += size;

					// ; ɗ烋[v𔲂
					ttxt.getstr( Str );
					if( strcmp( Str, ";" ) == 0 ) break;
				}
			}
			fprintf( cs, "\t\t};\n\n" );
		}
	}
	fprintf( cs, "\n" );
}

// x^o͂̊֐`o͂
void OutputBetaFunctionStr( FILE *cs, FILE *sc, FILE *def, FILE *hd )
{
	fprintf( cs, "\t\tpublic static VECTOR VGet( float x, float y, float z )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\tVECTOR Result ;\n" ) ;
	fprintf( cs, "\t\t\tResult.x = x ;\n" ) ;
	fprintf( cs, "\t\t\tResult.y = y ;\n" ) ;
	fprintf( cs, "\t\t\tResult.z = z ;\n" ) ;
	fprintf( cs, "\t\t\treturn Result ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static VECTOR VAdd( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\tVECTOR Result ;\n" ) ;
	fprintf( cs, "\t\t\tResult.x = In1.x + In2.x ;\n" ) ;
	fprintf( cs, "\t\t\tResult.y = In1.y + In2.y ;\n" ) ;
	fprintf( cs, "\t\t\tResult.z = In1.z + In2.z ;\n" ) ;
	fprintf( cs, "\t\t\treturn Result ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static VECTOR VSub( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\tVECTOR Result ;\n" ) ;
	fprintf( cs, "\t\t\tResult.x = In1.x - In2.x ;\n" ) ;
	fprintf( cs, "\t\t\tResult.y = In1.y - In2.y ;\n" ) ;
	fprintf( cs, "\t\t\tResult.z = In1.z - In2.z ;\n" ) ;
	fprintf( cs, "\t\t\treturn Result ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static float VDot( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\treturn In1.x * In2.x + In1.y * In2.y + In1.z * In2.z ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static VECTOR VCross( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\tVECTOR Result ;\n" ) ;
	fprintf( cs, "\t\t\tResult.x = In1.y * In2.z - In1.z * In2.y ;\n" ) ;
	fprintf( cs, "\t\t\tResult.y = In1.z * In2.x - In1.x * In2.z ;\n" ) ;
	fprintf( cs, "\t\t\tResult.z = In1.x * In2.y - In1.y * In2.x ;\n" ) ;
	fprintf( cs, "\t\t\treturn Result ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static VECTOR VScale( VECTOR In, float Scale )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\tVECTOR Result ;\n" ) ;
	fprintf( cs, "\t\t\tResult.x = In.x * Scale ;\n" ) ;
	fprintf( cs, "\t\t\tResult.y = In.y * Scale ;\n" ) ;
	fprintf( cs, "\t\t\tResult.z = In.z * Scale ;\n" ) ;
	fprintf( cs, "\t\t\treturn Result ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static float VSquareSize( VECTOR In )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\treturn In.x * In.x + In.y * In.y + In.z * In.z ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static VECTOR VTransform( VECTOR InV, MATRIX InM )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\tVECTOR Result ;\n" ) ;
	fprintf( cs, "\t\t\tResult.x = InV.x * InM.m00 + InV.y * InM.m10 + InV.z * InM.m20 + InM.m30 ;\n" ) ;
	fprintf( cs, "\t\t\tResult.y = InV.x * InM.m01 + InV.y * InM.m11 + InV.z * InM.m21 + InM.m31 ;\n" ) ;
	fprintf( cs, "\t\t\tResult.z = InV.x * InM.m02 + InV.y * InM.m12 + InV.z * InM.m22 + InM.m32 ;\n" ) ;
	fprintf( cs, "\t\t\treturn Result ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;
	fprintf( cs, "\t\tpublic static VECTOR VTransformSR( VECTOR InV, MATRIX InM )\n" ) ;
	fprintf( cs, "\t\t{\n" ) ;
	fprintf( cs, "\t\t\tVECTOR Result ;\n" ) ;
	fprintf( cs, "\t\t\tResult.x = InV.x * InM.m00 + InV.y * InM.m10 + InV.z * InM.m20 ;\n" ) ;
	fprintf( cs, "\t\t\tResult.y = InV.x * InM.m01 + InV.y * InM.m11 + InV.z * InM.m21 ;\n" ) ;
	fprintf( cs, "\t\t\tResult.z = InV.x * InM.m02 + InV.y * InM.m12 + InV.z * InM.m22 ;\n" ) ;
	fprintf( cs, "\t\t\treturn Result ;\n" ) ;
	fprintf( cs, "\t\t}\n\n" ) ;

	fprintf( cs, "\n\n" );

	fprintf( cs, "#if DX_USE_UNSAFE\n" );
	fprintf( cs, "\t\t[UnmanagedFunctionPointer(CallingConvention.Cdecl)]\n" ) ;
	fprintf( cs, "\t\tpublic unsafe delegate int SetActiveStateChangeCallBackFunctionCallback(int ActiveState, void* UserData);\n" );
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint = \"dx_SetActiveStateChangeCallBackFunction\")]\n" );
	fprintf( cs, "\t\textern unsafe static int dx_SetActiveStateChangeCallBackFunction(SetActiveStateChangeCallBackFunctionCallback Callback, void* UserData);\n" );
	fprintf( cs, "\t\tpublic unsafe static int SetActiveStateChangeCallBackFunction(SetActiveStateChangeCallBackFunctionCallback Callback, void* UserData)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\treturn dx_SetActiveStateChangeCallBackFunction(Callback, UserData);\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\n" ) ;
	fprintf( cs, "\t\t[UnmanagedFunctionPointer(CallingConvention.Cdecl)]\n" ) ;
	fprintf( cs, "\t\tpublic unsafe delegate void SetUseASyncChangeWindowModeFunctionCallback( void *Data );\n" );
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint = \"dx_SetUseASyncChangeWindowModeFunction\")]\n" );
	fprintf( cs, "\t\textern unsafe static int dx_SetUseASyncChangeWindowModeFunction( int Flag , SetUseASyncChangeWindowModeFunctionCallback CallBackFunction, void *Data );\n" );
	fprintf( cs, "\t\tpublic unsafe static int SetUseASyncChangeWindowModeFunction( int Flag , SetUseASyncChangeWindowModeFunctionCallback CallBackFunction, void *Data )\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\treturn dx_SetUseASyncChangeWindowModeFunction( Flag , CallBackFunction, Data );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "#endif\n" );
	fprintf( cs, "\t\t[UnmanagedFunctionPointer(CallingConvention.Cdecl)]\n" ) ;
	fprintf( cs, "\t\tpublic delegate void SetMenuItemSelectCallBackFunctionCallback( string ItemName, int ItemID );\n" );
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint = \"dx_SetMenuItemSelectCallBackFunction\")]\n" );
	fprintf( cs, "\t\textern static int dx_SetMenuItemSelectCallBackFunction( SetMenuItemSelectCallBackFunctionCallback CallBackFunction );\n" );
	fprintf( cs, "\t\tpublic static int SetMenuItemSelectCallBackFunction( SetMenuItemSelectCallBackFunctionCallback CallBackFunction )\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\treturn dx_SetMenuItemSelectCallBackFunction( CallBackFunction );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\n" ) ;
	fprintf( cs, "\t\t[UnmanagedFunctionPointer(CallingConvention.Cdecl)]\n" ) ;
	fprintf( cs, "\t\tpublic delegate void SetWindowMenuCallback( ushort ID );\n" );
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint = \"dx_SetWindowMenu\")]\n" );
	fprintf( cs, "\t\textern static int dx_SetWindowMenu( int MenuID, SetWindowMenuCallback MenuProc );\n" );
	fprintf( cs, "\t\tpublic static int SetWindowMenu( int MenuID, SetWindowMenuCallback MenuProc )\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\treturn dx_SetWindowMenu( MenuID, MenuProc );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\n" ) ;
	fprintf( cs, "\t\t[UnmanagedFunctionPointer(CallingConvention.Cdecl)]\n" ) ;
	fprintf( cs, "\t\tpublic delegate void SetRestoreShredPointCallback();\n" );
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint = \"dx_SetRestoreShredPoint\")]\n" );
	fprintf( cs, "\t\textern static int dx_SetRestoreShredPoint( SetRestoreShredPointCallback ShredPoint );\n" );
	fprintf( cs, "\t\tpublic static int SetRestoreShredPoint( SetRestoreShredPointCallback ShredPoint )\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\treturn dx_SetRestoreShredPoint( ShredPoint );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\n" ) ;
	fprintf( cs, "\t\t[UnmanagedFunctionPointer(CallingConvention.Cdecl)]\n" ) ;
	fprintf( cs, "\t\tpublic delegate void SetRestoreGraphCallbackCallback();\n" );
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint = \"dx_SetRestoreGraphCallback\")]\n" );
	fprintf( cs, "\t\textern static int dx_SetRestoreGraphCallback( SetRestoreGraphCallbackCallback Callback );\n" );
	fprintf( cs, "\t\tpublic static int SetRestoreGraphCallback( SetRestoreGraphCallbackCallback Callback )\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t\treturn dx_SetRestoreGraphCallback( Callback );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\n" ) ;
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint=\"dx_ClearDrawScreen\")]\n" );
	fprintf( cs, "\t\textern static int  dx_ClearDrawScreen( out RECT  ClearRect);\n" );
	fprintf( cs, "\t\tpublic static int  ClearDrawScreen( out RECT  ClearRect)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_ClearDrawScreen( out ClearRect );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  ClearDrawScreen()\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t    RECT temp;\n" );
	fprintf( cs, "\t\t\n" );
	fprintf( cs, "\t\t    temp.left = -1;\n" );
	fprintf( cs, "\t\t    temp.top = -1;\n" );
	fprintf( cs, "\t\t    temp.right = -1;\n" );
	fprintf( cs, "\t\t    temp.bottom = -1;\n" );
	fprintf( cs, "\t\t    return dx_ClearDrawScreen( out temp );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\t\n" );
	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint=\"dx_ClearDrawScreenZBuffer\")]\n" );
	fprintf( cs, "\t\textern static int  dx_ClearDrawScreenZBuffer( out RECT  ClearRect);\n" );
	fprintf( cs, "\t\tpublic static int  ClearDrawScreenZBuffer( out RECT  ClearRect)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_ClearDrawScreenZBuffer( out ClearRect );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int ClearDrawScreenZBuffer()\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t    RECT temp;\n" );
	fprintf( cs, "\t\t\n" );
	fprintf( cs, "\t\t    temp.left = -1;\n" );
	fprintf( cs, "\t\t    temp.top = -1;\n" );
	fprintf( cs, "\t\t    temp.right = -1;\n" );
	fprintf( cs, "\t\t    temp.bottom = -1;\n" );
	fprintf( cs, "\t\t    return dx_ClearDrawScreenZBuffer( out temp );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\t\n" );

	fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint=\"dx_SetKeyInputStringColor\")]\n" );
	fprintf( cs, "\t\textern static int  dx_SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE, ulong  IMEModeStrE, ulong  IMESelectWinE, ulong  IMESelectWinF, ulong  SelectStrBackColor, ulong  SelectStrColor, ulong  SelectStrEdgeColor);\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , 0 , 0 , 0 , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , 0 , 0 , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , IMESelectStrE , 0 , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE, ulong  IMEModeStrE)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , IMESelectStrE , IMEModeStrE , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE, ulong  IMEModeStrE, ulong  IMESelectWinE)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , IMESelectStrE , IMEModeStrE , IMESelectWinE , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE, ulong  IMEModeStrE, ulong  IMESelectWinE, ulong  IMESelectWinF)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , IMESelectStrE , IMEModeStrE , IMESelectWinE , IMESelectWinF , 0xffffffffffffffff , 0xffffffffffffffff , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE, ulong  IMEModeStrE, ulong  IMESelectWinE, ulong  IMESelectWinF, ulong  SelectStrBackColor)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , IMESelectStrE , IMEModeStrE , IMESelectWinE , IMESelectWinF , SelectStrBackColor , 0xffffffffffffffff , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE, ulong  IMEModeStrE, ulong  IMESelectWinE, ulong  IMESelectWinF, ulong  SelectStrBackColor, ulong  SelectStrColor)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , IMESelectStrE , IMEModeStrE , IMESelectWinE , IMESelectWinF , SelectStrBackColor , SelectStrColor , 0xffffffffffffffff );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( cs, "\t\tpublic static int  SetKeyInputStringColor( ulong  NmlStr, ulong  NmlCur, ulong  IMEStr, ulong  IMECur, ulong  IMELine, ulong  IMESelectStr, ulong  IMEModeStr, ulong  NmlStrE, ulong  IMESelectStrE, ulong  IMEModeStrE, ulong  IMESelectWinE, ulong  IMESelectWinF, ulong  SelectStrBackColor, ulong  SelectStrColor, ulong  SelectStrEdgeColor)\n" );
	fprintf( cs, "\t\t{\n" );
	fprintf( cs, "\t\t	return dx_SetKeyInputStringColor( NmlStr , NmlCur , IMEStr , IMECur , IMELine , IMESelectStr , IMEModeStr , NmlStrE , IMESelectStrE , IMEModeStrE , IMESelectWinE , IMESelectWinF , SelectStrBackColor , SelectStrColor , SelectStrEdgeColor );\n" );
	fprintf( cs, "\t\t}\n" );
	fprintf( hd, "int  __stdcall dx_SetKeyInputStringColor( ULONGLONG  NmlStr, ULONGLONG  NmlCur, ULONGLONG  IMEStr, ULONGLONG  IMECur, ULONGLONG  IMELine, ULONGLONG  IMESelectStr, ULONGLONG  IMEModeStr, ULONGLONG  NmlStrE = 0, ULONGLONG  IMESelectStrE = 0, ULONGLONG  IMEModeStrE = 0, ULONGLONG  IMESelectWinE = 0xffffffffffffffff, ULONGLONG  IMESelectWinF = 0xffffffffffffffff, ULONGLONG  SelectStrBackColor = 0xffffffffffffffff, ULONGLONG  SelectStrColor = 0xffffffffffffffff, ULONGLONG  SelectStrEdgeColor = 0xffffffffffffffff);\n" );
	fprintf( sc, "int  __stdcall dx_SetKeyInputStringColor( ULONGLONG  NmlStr, ULONGLONG  NmlCur, ULONGLONG  IMEStr, ULONGLONG  IMECur, ULONGLONG  IMELine, ULONGLONG  IMESelectStr, ULONGLONG  IMEModeStr, ULONGLONG  NmlStrE, ULONGLONG  IMESelectStrE, ULONGLONG  IMEModeStrE, ULONGLONG  IMESelectWinE, ULONGLONG  IMESelectWinF, ULONGLONG  SelectStrBackColor, ULONGLONG  SelectStrColor, ULONGLONG  SelectStrEdgeColor)\n" );
	fprintf( sc, "{\n" );
	fprintf( sc, "	return SetKeyInputStringColor( NmlStr, NmlCur, IMEStr, IMECur, IMELine, IMESelectStr, IMEModeStr, NmlStrE, IMESelectStrE, IMEModeStrE, IMESelectWinE, IMESelectWinF, SelectStrBackColor, SelectStrColor, SelectStrEdgeColor);\n" );
	fprintf( sc, "}\n" );
	fprintf( def, "\tdx_SetKeyInputStringColor\n" ) ;

	fprintf( cs, "\n\n" );

	fprintf( sc, "VECTOR __stdcall dx_VGet( float x, float y, float z )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\tVECTOR Result ;\n" ) ;
	fprintf( sc, "\tResult.x = x ;\n" ) ;
	fprintf( sc, "\tResult.y = y ;\n" ) ;
	fprintf( sc, "\tResult.z = z ;\n" ) ;
	fprintf( sc, "\treturn Result ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "VECTOR __stdcall dx_VAdd( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\tVECTOR Result ;\n" ) ;
	fprintf( sc, "\tResult.x = In1.x + In2.x ;\n" ) ;
	fprintf( sc, "\tResult.y = In1.y + In2.y ;\n" ) ;
	fprintf( sc, "\tResult.z = In1.z + In2.z ;\n" ) ;
	fprintf( sc, "\treturn Result ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "VECTOR __stdcall dx_VSub( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\tVECTOR Result ;\n" ) ;
	fprintf( sc, "\tResult.x = In1.x - In2.x ;\n" ) ;
	fprintf( sc, "\tResult.y = In1.y - In2.y ;\n" ) ;
	fprintf( sc, "\tResult.z = In1.z - In2.z ;\n" ) ;
	fprintf( sc, "\treturn Result ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "float __stdcall dx_VDot( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\treturn In1.x * In2.x + In1.y * In2.y + In1.z * In2.z ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "VECTOR __stdcall dx_VCross( VECTOR In1, VECTOR In2 )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\tVECTOR Result ;\n" ) ;
	fprintf( sc, "\tResult.x = In1.y * In2.z - In1.z * In2.y ;\n" ) ;
	fprintf( sc, "\tResult.y = In1.z * In2.x - In1.x * In2.z ;\n" ) ;
	fprintf( sc, "\tResult.z = In1.x * In2.y - In1.y * In2.x ;\n" ) ;
	fprintf( sc, "\treturn Result ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "VECTOR __stdcall dx_VScale( VECTOR In, float Scale )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\tVECTOR Result ;\n" ) ;
	fprintf( sc, "\tResult.x = In.x * Scale ;\n" ) ;
	fprintf( sc, "\tResult.y = In.y * Scale ;\n" ) ;
	fprintf( sc, "\tResult.z = In.z * Scale ;\n" ) ;
	fprintf( sc, "\treturn Result ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "float __stdcall dx_VSquareSize( VECTOR In )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\treturn In.x * In.x + In.y * In.y + In.z * In.z ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "VECTOR __stdcall dx_VTransform( VECTOR InV, MATRIX InM )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\tVECTOR Result ;\n" ) ;
	fprintf( sc, "\tResult.x = InV.x * InM.m[0][0] + InV.y * InM.m[1][0] + InV.z * InM.m[2][0] + InM.m[3][0] ;\n" ) ;
	fprintf( sc, "\tResult.y = InV.x * InM.m[0][1] + InV.y * InM.m[1][1] + InV.z * InM.m[2][1] + InM.m[3][1] ;\n" ) ;
	fprintf( sc, "\tResult.z = InV.x * InM.m[0][2] + InV.y * InM.m[1][2] + InV.z * InM.m[2][2] + InM.m[3][2] ;\n" ) ;
	fprintf( sc, "\treturn Result ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;
	fprintf( sc, "VECTOR __stdcall dx_VTransformSR( VECTOR InV, MATRIX InM )\n" ) ;
	fprintf( sc, "{\n" ) ;
	fprintf( sc, "\tVECTOR Result ;\n" ) ;
	fprintf( sc, "\tResult.x = InV.x * InM.m[0][0] + InV.y * InM.m[1][0] + InV.z * InM.m[2][0] ;\n" ) ;
	fprintf( sc, "\tResult.y = InV.x * InM.m[0][1] + InV.y * InM.m[1][1] + InV.z * InM.m[2][1] ;\n" ) ;
	fprintf( sc, "\tResult.z = InV.x * InM.m[0][2] + InV.y * InM.m[1][2] + InV.z * InM.m[2][2] ;\n" ) ;
	fprintf( sc, "\treturn Result ;\n" ) ;
	fprintf( sc, "}\n\n" ) ;



	fprintf( hd, "VECTOR __stdcall dx_VGet( float x, float y, float z ) ;\n" ) ;
	fprintf( def, "\tdx_VGet\n" ) ;
	fprintf( hd, "VECTOR __stdcall dx_VAdd( VECTOR In1, VECTOR In2 ) ;\n" ) ;
	fprintf( def, "\tdx_VAdd\n" ) ;
	fprintf( hd, "VECTOR __stdcall dx_VSub( VECTOR In1, VECTOR In2 ) ;\n" ) ;
	fprintf( def, "\tdx_VSub\n" ) ;
	fprintf( hd, "float __stdcall dx_VDot( VECTOR In1, VECTOR In2 ) ;\n" ) ;
	fprintf( def, "\tdx_VDot\n" ) ;
	fprintf( hd, "VECTOR __stdcall dx_VCross( VECTOR In1, VECTOR In2 ) ;\n" ) ;
	fprintf( def, "\tdx_VCross\n" ) ;
	fprintf( hd, "VECTOR __stdcall dx_VScale( VECTOR In, float Scale ) ;\n" ) ;
	fprintf( def, "\tdx_VScale\n" ) ;
	fprintf( hd, "float __stdcall dx_VSquareSize( VECTOR In ) ;\n" ) ;
	fprintf( def, "\tdx_VSquareSize\n" ) ;
	fprintf( hd, "VECTOR __stdcall dx_VTransform( VECTOR InV, MATRIX InM ) ;\n" ) ;
	fprintf( def, "\tdx_VTransform\n" ) ;
	fprintf( hd, "VECTOR __stdcall dx_VTransformSR( VECTOR InV, MATRIX InM ) ;\n" ) ;
	fprintf( def, "\tdx_VTransformSR\n" ) ;
}

// ֐`o͂
void OutputFunctionStr( FILE *cs, FILE *sc, FILE *def, FILE *hd )
{
	char Str[256], Str2[2024 * 10], Str3[256], DllFuncName[ 256 ] ;
	char *start;
	bool unsafe;
	int i, j, k, l, size, funccount;
	FUNCTION Func;

	// x^̏o
	OutputBetaFunctionStr( cs, sc, def, hd ) ;

	ttxt.setmem( dat.Function );
	for(;;)
	{
		PARAMETER *par;
		char *FuncStart ;

		// 擾
		if( ttxt.getstr( Str ) == false ) break;

		// CC֐̓XLbv
		if( strcmp( Str, "__inline" ) == 0 )
		{
			ttxt.search( "{" ) ;
			ttxt.search( "}" ) ;
			continue ;
		}
		else
		// extern ȊO̓XLbv
		if( strcmp( Str, "extern" ) != 0 )
		{
			continue ;
		}

		// ֐̃JE^
		funccount = 0x0ccccccc ;

		// ݂̕ʒuۑ
		FuncStart = ttxt.getpos() ;

		// unsafe ǂ̃tO|Ă
		unsafe = false ;

		// C# pɏo͂łȂ߂ľ^̏ꍇ DLL ɂ̂ݏo͂
		if( CheckSkipType( &ttxt, true, &unsafe ) == true ) goto CPPOUTONLY;

		// ߂ľ^擾
		size = TypeConv( &ttxt, Func.CSType, false, Func.CPPType, NULL, false, unsafe );

		// void ^ǂۑ
		Func.Void = size == 0;

		// ֐擾
		ttxt.getstr( Func.Name );

		// ֐̓o^
		funccount = AddFunctionName( Func.Name ) ;

		// Ώۂ̊֐ǂ𒲂ׂ
		i = CheckSkipFunc( Func.Name ) ;

		// S̏ꍇ͉Ɏ
		if( i == 2 ) continue ;

		// ߂l 1 ̏ꍇ DLL ɂ̂ݏo͂
		if( i == 1 ) goto CPPOUTONLY;

		// 
		{
			// ̊Jnʒuۑ
			ttxt.getstr( Str );
			start = ttxt.getpos();

			// ŏ̂Q񂩂ׂ
			ttxt.getstr( Str );
			ttxt.getstr( Str2 );
			ttxt.move( start );
			if( strcmp( Str, ")" ) == 0 || ( strcmp( Str, "void" ) == 0 && strcmp( Str2, ")" ) == 0 ) )
			{
				// ꍇ
				Func.DefaultNum = 0;
				Func.ParameterNum = 0;
				if( strcmp( Str, "void" ) == 0 )
					ttxt.getstr( Str );
			}
			else
			{
				// ꍇ
				i = 0;
				par = Func.Parameter;
				Func.DefaultNum = 0;
				for(;;)
				{
					// ̌^ C# ɏo͂ł邩ǂ`FbN
					if( CheckSkipType( &ttxt, false, &unsafe ) == true )
					{
						i = -1;
						break;
					}

					// C#p̈̌^𓾂
					TypeConv( &ttxt, par->CSType, false, par->CPPType, &par->Out, false, unsafe );

					// 擾
					ttxt.getstr( par->Name );

					// ^̎ ( ꍇ͊֐|C^Ȃ̂ŁAϊł C# ɏo͂łȂ
					if( strcmp( par->Name, "(" ) == 0 )
					{
						i = -1;
						break;
					}

					// ftHg邩ǂ̃`FbN
					par->ValidDefault = false;
					if( ttxt.nextchar() == '=' )
					{
						// ftHg擾
						ttxt.getstr( Str );
						par->ValidDefault = true;
						ttxt.getstr( par->Default );
						Func.DefaultNum ++ ;
					}

					par ++ ;
					i ++ ;
					ttxt.getstr( Str );
					if( strcmp( Str, ")" ) == 0 ) break;
				}

				// G[ DLL ɂ̂ݏo͂
				if( i == -1 )
				{
					goto CPPOUTONLY;
				}

				// ̐ۑ
				Func.ParameterNum = i;
			}
			ttxt.getstr( Str );
		}

		// ̊֐ĂȂꍇ dx_֐  DLL ̊֐ɂ
		if( funccount == 1 )
		{
			sprintf( DllFuncName, "dx_%s", Func.Name );
		}
		else
		// Qڈȏ̏ꍇ dx_֐_ڂ  DLL ̊֐ɂ
		{
			sprintf( DllFuncName, "dx_%s_%d", Func.Name, funccount );
		}

		// unsafe ̏ꍇ̓}No͂
		if( unsafe )
		{
			fprintf( cs, "#if DX_USE_UNSAFE\n" );
		}

		// C# p̊֐錾o
		fprintf( cs, "\t\t[DllImport(\"DxLib.dll\", EntryPoint=\"%s\")]\n", DllFuncName );
		fprintf( cs, "\t\textern %sstatic %s %s( ", unsafe ? "unsafe " : "", Func.CSType, DllFuncName );

		// DLL ւ̏o͊֐Xgɏo
		fprintf( def, "\t%s\n", DllFuncName ) ;

		// o
		par = Func.Parameter;
		for( i = 0; i < Func.ParameterNum; i ++, par ++ )
		{
			fprintf( cs, "%s %s", par->CSType, par->Name );
			if( i != Func.ParameterNum - 1 )
			{
				fprintf( cs, ", " );
			}
		}
		fprintf( cs, ");\n" );

		// C#p֐o
		{
			// unsafe ֐łȂ void * ȊO out ̈ꍇ̓ftHg֐ C# ŃG~[głȂ̂
			// ̂悤Ȉ邩ǂׂ
			par = Func.Parameter ;
			for( l = 0 ; l < Func.ParameterNum ; l ++, par ++ )
			{
				if( par->ValidDefault && par->Out )
				{
					if( unsafe == false || strcmp( par->CSType, "void * " ) != 0 )
					{
						// ftHg𖳌ɂ
						Func.DefaultNum = 0;
						par = Func.Parameter ;
						for( k = 0 ; k < Func.ParameterNum ; k ++, par ++ )
						{
							par->ValidDefault = false ;
						}
						break ;
					}
				}
			}

			// ftHg̏o͂ƁAftHg̐֐쐬Kv̂ł̃[v
			for( j = 0 ; j <= Func.DefaultNum ; j ++ )
			{
				// ߂ľ^Ɗ֐̏o
				fprintf( cs, "\t\tpublic %sstatic %s %s( ", unsafe ? "unsafe " : "", Func.CSType, Func.Name );

				// p[^`̏o
				par = Func.Parameter;
				k = 0;
				for( i = 0; i < Func.ParameterNum; i ++, par ++ )
				{
					// ftHggpꍇ͂ȍ~̈̏o͍͂sȂ
					if( par->ValidDefault )
					{
						k ++ ;
						if( k > j ) break;
					}

					// ƈ̊Ԃ̏o
					if( i != 0 )
					{
						fprintf( cs, ", " );
					}

					// ̌^ƈ̏o
					fprintf( cs, "%s %s", par->CSType, par->Name );
				}
				fprintf( cs, ")\n" );

				// ֐̒go
				fprintf( cs, "\t\t{\n" );

				// out ^CṽftHǵA[Jϐŏo͂󂯎悤ɂ
				par = Func.Parameter;
				k = 0;
				for( i = 0; i < Func.ParameterNum; i ++, par ++ )
				{
					if( par->ValidDefault == 0 ) continue ;
					if( k >= j && par->Out && strcmp( par->CSType, "string " ) != 0 && strcmp( par->CSType, "void * " ) != 0 )
					{
						fprintf( cs, "\t\t\t%s%s;\n", par->CSType[0] == 'o' && par->CSType[1] == 'u' && par->CSType[2] == 't' && par->CSType[3] == ' ' ? &par->CSType[ 4 ] : par->CSType, par->Name ) ;
					}
					k ++ ;
				}

				// void ^̏ꍇ return o͂Ȃ
				if( Func.Void == false )
				{
					fprintf( cs, "\t\t\treturn " );
				}
				else
				{
					fprintf( cs, "\t\t\t" );
				}

				// DLL ̊֐o
				fprintf( cs, "%s( ", DllFuncName ) ;

				// o
				par = Func.Parameter;
				k = 0;
				for( i = 0; i < Func.ParameterNum; i ++, par ++ )
				{
					// ؂ , o
					if( i != 0 )
					{
						fprintf( cs, ", " );
					}

					// ftHg邩ǂŕ
					if( par->ValidDefault && k >= j )
					{
						// ftHg NULL ǂŏ𕪊
						if( strcmp( par->Default, "NULL" ) == 0 )
						{
							// string  void * ̏ꍇ null o
							if( strcmp( par->CSType, "string " ) == 0 || strcmp( par->CSType, "void * " ) == 0 )
							{
								fprintf( cs, "null " );
							}
							else
							// ȊȌꍇ͈Ɠ̃[Jϐ`Ă̂łg
							if( unsafe )
							{
								fprintf( cs, "%s ", par->Name ) ;
							}
							else
							{
								fprintf( cs, "out %s ", par->Name ) ;
							}
						}
						else
						{
							// NULL ȊȌꍇ̓|C^nł͂Ȃ̂ŁAftHgl̂܂܏o͂
							fprintf( cs, "%s ", par->Default );
						}
					}
					else
					{
						// ftHgꍇ

						// out 邩ǂŏ𕪊
						if( par->Out )
						{
							// out ł System.Text.StringBuilder  unsafe ̏ꍇ͂̂܂ܕϐo
							if( strncmp( par->CSType, "System.Text.StringBuilder", strlen( "System.Text.StringBuilder" ) ) == 0 || unsafe )
							{
								fprintf( cs, "%s ", par->Name );
							}
							else
							// ȊȌꍇ out t
							{
								fprintf( cs, "out %s ", par->Name );
							}
						}
						else
						{
							// out ꍇ͕ʂɏo
							fprintf( cs, "%s ", par->Name );
						}
					}

					// ftHgꍇ̓JE^CNg
					if( par->ValidDefault )
						k ++ ;
				}
				fprintf( cs, ");\n" );
				fprintf( cs, "\t\t}\n" );
			}
		}

		// DLLp֐o
		{
			// GetColor ʏ
			if( strcmp( Func.CPPType, "DWORD " ) == 0 && strcmp( Func.Name, "GetColor" ) == 0 )
			{
				fprintf( hd, "int __stdcall dx_GetColor( " );
				fprintf( sc, "int __stdcall dx_GetColor( " );
			}
			else
			{
				// ̊֐ꍇ͊֐̌ɉڂ̔ԍo͂
				if( funccount == 1 )
				{
					fprintf( hd, "%s __stdcall dx_%s( ", Func.CPPType, Func.Name );
					fprintf( sc, "%s __stdcall dx_%s( ", Func.CPPType, Func.Name );
				}
				else
				{
					fprintf( hd, "%s __stdcall dx_%s_%d( ", Func.CPPType, Func.Name, funccount );
					fprintf( sc, "%s __stdcall dx_%s_%d( ", Func.CPPType, Func.Name, funccount );
				}
			}

			// ̏o
			{
				// ꍇ void o͂ďI
				if( Func.ParameterNum == 0 )
				{
					fprintf( hd, "void" );
					fprintf( sc, "void" );
				}
				else
				{
					// o
					par = Func.Parameter;
					for( i = 0; i < Func.ParameterNum; i ++, par ++ )
					{
						// ؂蕶̏o
						if( i != 0 )
						{
							fprintf( hd, ", " );
							fprintf( sc, ", " );
						}

						// ̌^ƈo
						fprintf( hd, "%s %s", par->CPPType, par->Name );
						fprintf( sc, "%s %s", par->CPPType, par->Name );

						// ftHgꍇ͂o
						if( par->ValidDefault )
						{
							fprintf( hd, " = %s", par->Default );
						}
					}
				}
				fprintf( hd, ");\n" );
				fprintf( sc, ")\n" );
			}

			// ֐̒go
			{
				fprintf( sc, "{\n" );

				// ߂l void ^ȊȌꍇ return o
				if( Func.Void )
				{
					fprintf( sc, "\t" );
				}
				else
				{
					fprintf( sc, "\treturn " );
				}

				// ֐̏o
				fprintf( sc, "%s( ", Func.Name );

				// ̏o
				par = Func.Parameter;
				for( i = 0; i < Func.ParameterNum; i ++, par ++ )
				{
					if( i != 0 )
					{
						fprintf( sc, ", " );
					}
					fprintf( sc, "%s", par->Name );
				}
				fprintf( sc, ");\n" );
				fprintf( sc, "}\n" );
			}
		}

		// unsafe ̏ꍇ̓}N̏I[o͂
		if( unsafe )
		{
			fprintf( cs, "#endif\n" );
		}
		fprintf( cs, "\n" );

		continue ;

		// DLL ɂ̂ݏo͂ꍇ
CPPOUTONLY:
		ttxt.move( FuncStart ) ;

		// ֐̖߂l void ^ǂZbg
		ttxt.getstr( Str ) ;
		Func.Void = strcmp( Str, "void" ) == 0 ? 1 : 0 ;

		// ֐̖߂ľ^Ɗ֐o
		{
			fprintf( hd, "%s ", Str ) ;
			fprintf( sc, "%s ", Str ) ;

			// ֐Ƃ܂ŕo
			for(;;)
			{
				ttxt.getstr( Str ) ;
				if( Str[ 0 ] == '*' ) Func.Void = 0 ;
				if( ttxt.nextchar() == '(' ) break ;
				fprintf( hd, "%s ", Str ) ;
				fprintf( sc, "%s ", Str ) ;
			}
		}

		// ֐ۑ
		strcpy( Func.Name, Str ) ;

		// ֐o^܂֐o^
		if( funccount == 0x0ccccccc )
		{
			funccount = AddFunctionName( Func.Name ) ;
		}

		// DLL ł̊֐̍쐬
		if( funccount == 1 )
		{
			sprintf( Str2, "dx_%s", Func.Name ) ;
		}
		else
		{
			sprintf( Str2, "dx_%s_%d", Func.Name, funccount ) ;
		}

		// ֐o
		fprintf( def, "\t%s\n", Str2 ) ;
		fprintf( hd, "__stdcall %s( ", Str2 ) ;
		fprintf( sc, "__stdcall %s( ", Str2 ) ;

		// ̏o
		{
			Func.ParameterNum = 0 ;
			ttxt.getstr( Str ) ;
			ttxt.getstr( Str ) ;

			// ꍇ void Ƃo͂
			if( strcmp( Str, "void" ) == 0 && ttxt.nextchar() != '*' && ttxt.nextchar() != '(' )
			{
				ttxt.getstr( Str ) ;
				ttxt.getstr( Str ) ;
				fprintf( hd, "void )" ) ;
				fprintf( sc, "void )" ) ;
			}
			else
			{
				for(;;)
				{
					ttxt.getstr( Str2 ) ;

					// R߂ * ̏ꍇ͏𕪊
					if( ttxt.nextchar() == '*' )
					{
						ttxt.getstr( Str3 ) ;

						// Qڂ ( ̏ꍇ͈͊֐|C^
						if( Str2[ 0 ] == '(' )
						{
							// ֐|C^̏ꍇ͂Sڂ
							ttxt.getstr( Func.Parameter[ Func.ParameterNum ].Name ) ;

							// ) ̎擾
							ttxt.getstr( Str2 ) ;

							// ֐|C^̈̏o
							fprintf( hd, "%s ( *%s )", Str, Func.Parameter[ Func.ParameterNum ].Name ) ;
							fprintf( sc, "%s ( *%s )", Str, Func.Parameter[ Func.ParameterNum ].Name ) ;

							// ֐|C^̊֐̈o͂
							for(;;)
							{
								ttxt.getstr( Str ) ;
								if( Str[0] == ')' ) break ;
								fprintf( hd, "%s ", Str ) ;
								fprintf( sc, "%s ", Str ) ;
							}
							fprintf( hd, "%s ", Str ) ;
							fprintf( sc, "%s ", Str ) ;
						}
						else
						{
							// ֐|C^ȊȌꍇ͕ʂ̃|C^Ƃďo
							ttxt.getstr( Func.Parameter[ Func.ParameterNum ].Name ) ;
							fprintf( hd, "%s %s * %s ", Str, Str2, Func.Parameter[ Func.ParameterNum ].Name ) ;
							fprintf( sc, "%s %s * %s ", Str, Str2, Func.Parameter[ Func.ParameterNum ].Name ) ;
						}
					}
					else
					// |C^ unsigned int ̏ꍇ͕ʂɏo
					if( Str2[ 0 ] == '*' || strcmp( Str2, "int" ) == 0 )
					{
						ttxt.getstr( Func.Parameter[ Func.ParameterNum ].Name ) ;
						fprintf( hd, "%s %s %s ", Str, Str2, Func.Parameter[ Func.ParameterNum ].Name ) ;
						fprintf( sc, "%s %s %s ", Str, Str2, Func.Parameter[ Func.ParameterNum ].Name ) ;
					}
					else
					// ȊȌꍇʂɏo
					{
						strcpy( Func.Parameter[ Func.ParameterNum ].Name, Str2 ) ;
						fprintf( hd, "%s %s ", Str, Func.Parameter[ Func.ParameterNum ].Name ) ;
						fprintf( sc, "%s %s ", Str, Func.Parameter[ Func.ParameterNum ].Name ) ;
					}
					Func.ParameterNum ++ ;

					ttxt.getstr( Str ) ;
					if( Str[ 0 ] == '=' )
					{
						// ftHgꍇ͋؂蕶܂ŏo
						for(;;)
						{
							fprintf( hd, "%s ", Str ) ;
							ttxt.getstr( Str ) ;
							if( Str[ 0 ] == ',' || Str[ 0 ] == ')' )
								break ;
						}
						fprintf( hd, "%s ", Str ) ;
						fprintf( sc, "%s ", Str ) ;
					}
					else
					{
						fprintf( hd, "%s ", Str ) ;
						fprintf( sc, "%s ", Str ) ;
					}

					// ) I
					if( Str[ 0 ] == ')' ) break ;
					ttxt.getstr( Str ) ;
				}
				ttxt.getstr( Str ) ;
			}
			fprintf( hd, ";\n" ) ;
			fprintf( sc, "\n" ) ;
		}

		// ֐̒g̏o
		{
			fprintf( sc, "{\n" ) ;

			// ߂ľ^ void ȊȌꍇ return t
			if( Func.Void )
			{
				fprintf( sc, "\t %s( ", Func.Name ) ;
			}
			else
			{
				fprintf( sc, "\treturn %s( ", Func.Name ) ;
			}

			// ̏o
			for( i = 0 ; i < Func.ParameterNum ; i ++ )
			{
				fprintf( sc, "%s ", Func.Parameter[ i ].Name ) ;
				if( i != Func.ParameterNum - 1 )
				{
					fprintf( sc, ", " ) ;
				}
			}
			fprintf( sc, " ) ;\n" ) ;
			fprintf( sc, "}\n" ) ;
		}
	}
	fprintf( cs, "\n\n" );
}

// main֐
void main( int argc, char **argv )
{
	FILE *hd, *sc, *cs, *def, *def2;

	// p[^ 2 wvo͂ďI
	if( argc != 3 )
	{
		printf( "MakeDLLFile.exe DxLibHeaderPath DxDirectXHeaderPath\n" );
		return;
	}

	// DxLib.h ̓ǂݍ
	if( dhtxt.load( argv[1] ) == false ) return;

	// DxDirectX.h ̓ǂݍ
	if( dxtxt.load( argv[2] ) == false ) return;

	// Ӗ̂؂ɃXy[X̍쐬
	CreateTokenStr();

	// o͐̃t@CJ
	hd = fopen( "DxDLL.h", "wt" );
	sc = fopen( "DxDLL.cpp", "wt" );
	cs = fopen( "DxDLL.cs", "wt" );
	def = fopen( "DxDLL.def", "wt" ) ;

	// 擪̏o
	fprintf( def, "LIBRARY DxLib\n\nEXPORTS\n" ) ;

	fprintf( hd, "#include \"DxLib.h\"\n" );
	fprintf( hd, "extern \"C\"\n{\n " );
	fprintf( sc, "#include \"DxDLL.h\"\n" );
	fprintf( sc, "#define DX_CHAR char\n" );

	fprintf( cs, "using System.Runtime.InteropServices;\n" );
	fprintf( cs, "namespace DxLibDLL\n" );
	fprintf( cs, "{\n" );
	fprintf( cs, "\tpublic static class DX\n" );
	fprintf( cs, "\t{\n" );

	// 萔` C# ̃t@Cɏo͂
	OutputDefineStr( cs ) ;

	// \̕o͂
	OutputStructStr( cs ) ;

	// ֐o͂
	OutputFunctionStr( cs, sc, def, hd ) ;

	// I[o
	fprintf( hd, "}\n" );
	fprintf( cs, "\t}\n" );
	fprintf( cs, "}\n" );

	// t@C
	fclose( hd );
	fclose( sc );
	fclose( cs );
	fclose( def ) ;

	// DxLib.h ̉
	dhtxt.release() ;

	// DxDirectX.h ̉
	dxtxt.release() ;
}




